function [ N, topn ] = add_zero_terms( N, topn )

% Hyper-Learning Code: Hyper-learn the best model of text documents
% Copyright (C) 2005  Jaime Teevan
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

% Number of terms is given as a constant:
numUniqueTerms = 645183;  % From Constants.java in ParseTREC

% We couldn't count the non-occurring terms just by looking at the
% documents, as they only include terms that _occur_.  So add in
% the all zero term.

% Make the zero term:
zero_term = zeros( size(N,1), 1 );   % First, make all zero vector
zero_term( 1 ) = sum( N(:,1) );      % Occurs in all docs zero times

% Figure out how many terms have this pattern
num_zts =  numUniqueTerms - sum( topn );

N = [ zero_term N ];
topn = [ num_zts topn ];