function a = get_a( f, h, N )

% Hyper-Learning Code: Hyper-learn the best model of text documents
% Copyright (C) 2005  Jaime Teevan
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

% Find the a needed for the polynomial used as a root of the derivative
% of log Q WRT phi.  a = (\bar{h}-h)f where \bar{h} is unique for each
% term and is equal to the sum over k of n_i^t/n * h_i

k = size(N,1)-1;
T = size(N,2);

normalized_N = N ./ repmat( sum(N), k+1, 1 );
h_bar = repmat( h, 1, T ) .* normalized_N;

a = ( h_bar - repmat( h, 1, T ) ) .* repmat( f, 1, T );