function [ examples, topn ] = get_ex_terms( documents )

% Hyper-Learning Code: Hyper-learn the best model of text documents
% Copyright (C) 2005  Jaime Teevan
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

% What we want is, given a set of documents, the term patterns that
% occur in those documents.

% Documents is a matrix of term vectors.
% Each row represents a document.
% Each column represents a term.

% Examples is a matrix with each column an example term occurrence pattern.
% The patterns are unique, and the columns correspond to a unique phi val.

% topn stands for "term occurrence pattern n", which counts the number of
% times each a term with the pattern corresponding to the example occurred.

% Sort documents to get similar term patterns next to eachother.
sdocs = sortrows( sort( documents )' )';

% Now we just need to go through and merge rows together.
[ examples, topn ] = compress_columns( sdocs );
