function ns = get_ns( term_vec, cap )

% Hyper-Learning Code: Hyper-learn the best model of text documents
% Copyright (C) 2005  Jaime Teevan
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

% Takes a column vector where each entry represents the number of times
% the term has occurred in a document.

% Return a column vector with the number of times term occurs n times.
% size( ns ) = ( (cap+1), 1 )
% Caps at number of times term occurs <cap> times

ns = zeros( cap+1, 1 );

for i = 1:cap,
  ns( i ) = sum( term_vec == i-1 );
end

% Want to find the number that occurred <cap> number of times or more.
ns( cap+1 ) = sum( term_vec >= cap );