function phi = get_phi( f, h, N )

% Hyper-Learning Code: Hyper-learn the best model of text documents
% Copyright (C) 2005  Jaime Teevan
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

phi = [];

% Want to make equal to zero:
% sum over k of h_i (n_i^t/N - P_i^t)

for index = 1:size( N, 2 )

  n = N( :, index );

  x = 0;

  % Check to see if term is the non-occurring term.
  if( sum( n( 2:length(n) ) ) == 0 )
    [ val, imax ] = max( h );
    [ val, imin ] = min( h );
    if( imax==1 )
      x = 1000;
    end
    if( imin == 1 )
      x = -1000;
    end
  end

  if( x == 0 )
    x = fzero( 'phi_wrapper', 5, optimset, f, h, n );

    if isnan(x) | x == Inf | x == -Inf
      x = get_bad_phi( f, h, n );

    % It did work -- since we were operating in the e_to_phi world,
    % the phi is actually the log of what we found.
    else
      x = log( x );
    end
  end

  phi = [ phi x ];

end