function [ N, topn ] = get_working_N( documents, cap, k )

% Hyper-Learning Code: Hyper-learn the best model of text documents
% Copyright (C) 2005  Jaime Teevan
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

% Gets the term occurrence patterns and returns them in a matrix, N
% and the number of times each term occurrence patter occurs, returned in vector topn

[ ex, topn ] = get_ex_terms( documents );
ex( ex>cap ) = cap; % cap term occurrence
N = get_N( ex, k );
[ N, topn ] = compress_columns( N, topn ); % Optional, save some space
[ N, topn ] = add_zero_terms( N, topn );