function gradient = h_gradient( A, cphi )

% Hyper-Learning Code: Hyper-learn the best model of text documents
% Copyright (C) 2005  Jaime Teevan
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

% Finds the gradients for all of the hs
% Returns a column vector of size k+1 with the gradient for each h_i at
% position i

% Desired: sum_(t=0)^T (cphi^t(n_m^t-p_i^t*sum_{i=0}^k n_i^t))
gradient = sum( A .* repmat( cphi, size( A, 1 ), 1 ), 2 );
