function gradient = phi_gradient( f, h, phi, N )

% Hyper-Learning Code: Hyper-learn the best model of text documents
% Copyright (C) 2005  Jaime Teevan
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

% Finds the gradients for all of the phis
% Returns a row vector of size T with the gradient for each phi_t at
% position t

% Desired: sum_{i=0}^k( h_i (n_i^t - N p_i^t) )
P = get_P( f, h, phi );
num_docs = sum( N(:,1) );

h_matrix = repmat( h, 1, size( N, 2 ) );
gradient = sum( h_matrix .* (N - num_docs*P) );


