function gradient = phi_wrapper( e_to_phi, f, h, N )

% Hyper-Learning Code: Hyper-learn the best model of text documents
% Copyright (C) 2005  Jaime Teevan
% 
% This program is free software; you can redistribute it and/or
% modify it under the terms of the GNU General Public License
% as published by the Free Software Foundation; either version 2
% of the License, or (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

% Because phi is in the exponent, we don't really want it searching over
% phi (bad news when it gets too large) but rather want it searching over
% e^phi.  So get out phi by taking the log of that.

% NOTE: this means e_to_phi can't be negative.  This lower bound
% allows phi to be -100, but not lower.  (Well, it can be lower, just the
% sign change finding won't work very well ...)
if( e_to_phi <= 0 ) e_to_phi = exp( -100 ); end

gradient = phi_gradient( f, h, log( e_to_phi ), N );

